unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, ComCtrls,
  gfx_files  ,
  XComun,UFPuntuales;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Editar1: TMenuItem;
    FPuntuales1: TMenuItem;
    Abrir1: TMenuItem;
    Salvar1: TMenuItem;
    N1: TMenuItem;
    Salir1: TMenuItem;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Negativo1: TMenuItem;
    Grises1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Abrir1Click(Sender: TObject);
    procedure Grises1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Negativo1Click(Sender: TObject);
  private
    { Private declarations }

    procedure Mostrar(BM : TBitMap; Image : TImage);
  public
    { Public declarations }
    M1,M2  : XComun.XMat;
    BM1    : TBitMap;
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}


procedure TForm1.Mostrar(BM : TBitMap; Image : TImage);
begin
  Image.Picture.Assign(BM);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BM1  := TBitMap.Create;
end;

procedure TForm1.Abrir1Click(Sender: TObject);
var
  nom : string;
begin

  OpenDialog1.Filter := gfx_files._OpenFilterString;
  if OpenDialog1.Execute() then begin
    nom := OpenDialog1.FileName;
    gfx_files.LoadAnyImageToBMP(BM1,nom,false,0,0);
    UG_BM2Mat(BM1,M1);

    Image1.Picture.Assign(BM1);
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y:
    Integer);
var
  col,r,g,b : integer;
begin
  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  col := Image1.Canvas.Pixels[X,Y];
  r   := GetRValue(col);
  g   := GetGValue(col);
  b   := GetBValue(col);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);

end;

procedure TForm1.Negativo1Click(Sender: TObject);
begin
  if (M2.nc<>0) and (M2.nr<>0) then UG_CopiaM2M(M2,M1);
  XFP_Neg(M1,M2);
  UG_Mat2BM(M2,BM1);
  Mostrar(BM1,Image1);
end;

procedure TForm1.Grises1Click(Sender: TObject);
begin
  if (M2.nc<>0) and (M2.nr<>0) then UG_CopiaM2M(M2,M1);
  XFP_Gris(M1,M2);
  UG_Mat2BM(M2,BM1);
  Mostrar(BM1,Image1);
end;


end.
